/**
 * Created by albert on 14/04/2016.
 */
angular.module('api.order', ['ngResource'])
.service('orderService', function($resource, context) {
  'use strict';
  var getOrders = $resource(context.constants.API_BASE + '/api/orders', {}, context.httpMethods(['QUERY']));

  var getMybellboy = $resource(context.constants.API_BASE + '/api/orders/:username', {
    'username': '@username'
  }, context.httpMethods(['QUERY']));

  var getOrder = $resource(context.constants.API_BASE + '/api/order/:id', {
    'id': '@id'
  }, context.httpMethods(['GET']));

  var getOrderByStatus = $resource(context.constants.API_BASE + '/api/orderByStatus/:status/:username', {
    'status': '@status',
    'username': '@username'
  }, context.httpMethods(['GET']));

  var createOrder = $resource(context.constants.API_BASE + '/api/order', {
    'price': '@price',
    'foodList': '@foodList'
  }, context.httpMethods(['POST']));

  var updateOrder = $resource(context.constants.API_BASE + '/api/order/:id', {
    'id': '@id'
  }, context.httpMethods(['PUT']));

  return {
    getOrders: getOrders.query,
    getMybellboy: getMybellboy.query,
    getOrder: getOrder.get,
    getOrderByStatus: getOrderByStatus.get,
    createOrder: createOrder.create,
    updateOrder: updateOrder.update
  };

});
