/**
 * Created by albert on 14/04/2016.
 */
angular.module('context', [])
.factory('context', function() {
  'use strict';
  return {
    httpMethods: function(methods) {
      var data = {};

      methods.map(function(method) {
        switch (method) {
          case 'QUERY':
            data.query = {
              method: 'GET',
              isArray: true
            };
            break;
          case 'GET':
            data.get = {
              method: 'GET'
            };
            break;
          case 'POST':
            data.create = {
              method: 'POST',
              withCredentials: true,
              headers: {
                'Content-Type': 'application/json'
              }
            };
            data.post = {
              method: 'POST',
              headers: {
                'Content-Type': 'application/x-www-form-urlencoded'
              },
              transformRequest: function(obj) {
                var str = [];
                for (var p in obj) {
                  str.push(encodeURIComponent(p) + '=' + encodeURIComponent(obj[p]));
                }
                return str.join('&');
              }
            };
            data.go = {
              method: 'POST'
            };
            data.multipart = {
              method: 'POST',
              headers: {
                'Content-Type': undefined
              },
              transformRequest: function(data) {
                var fd = new FormData();

                angular.forEach(data, function(value, key) {
                  if (typeof(value) === 'object' && value[0] && value[0]['size']) {
                    value = value[0];
                  }

                  fd.append(key, value);
                });

                return fd;
              }
            };
            break;
          case 'PUT':
            data.update = {
              method: 'PUT'
            };
            break;
          case 'DELETE':
            data.delete = {
              method: 'DELETE'
            };
            break;
        }
      });

      return data;
    },
    constants: {
      URL_BASE: '@@api_url@@',
      API_BASE: 'http://139.59.172.191:3001',
      REGEXPS: {
        email: /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
      }
    }
  };

});
