/**
 * Created by albert on 17/04/2016.
 */

angular.module('app.shoppingCart', [])
  .directive('shoppingCart', function() {
    'use strict';
    return{
      replace: true,
      scope: {
        order: '='
      },
      templateUrl: 'app/common/shoppingCart/shoppingCart.html',
      controller: 'ShoppingCartController as shoppingCartCtrl'
    };
  })
  .controller('ShoppingCartController', function($scope, $rootScope, $ionicSideMenuDelegate, $ionicPopup, orderService, order){
    var vm = this;

    vm.removeItem = function(index){
      $scope.order.price = $scope.order.price - $scope.order.foodList[index].price;
      $scope.order.foodList.splice(index, 1);

      if($scope.order.foodList.length === 0){
        $ionicSideMenuDelegate.toggleRight();
      }

      orderService.updateOrder({id: $scope.order._id, price: $scope.order.price, status: $scope.order.status, foodList: $scope.order.foodList});
    };

    vm.finishOrder = function(){
      vm.disableButton = true;

      orderService.updateOrder({id: $scope.order._id, price: $scope.order.price, status: order.COMPLETED, foodList: $scope.order.foodList})
        .$promise.then(function(){
          $rootScope.$emit('shoppingCart', null);
            $ionicSideMenuDelegate.toggleRight();
            vm.disableButton = false;
          $rootScope.showAlert('Comanda feta!', 'Gràcies per realitza la seva comanda.');
        },
        function(){
          $ionicSideMenuDelegate.toggleRight();
          vm.disableButton = false;
          showConfirm('Error en la comanda!', 'Hi ha hagut un error, vol intentar-ho de nou?');
        });
    };

    // A confirm dialog
    function showConfirm(title, message) {
      var confirmPopup = $ionicPopup.confirm({
        title: title,
        template: message
      });

      confirmPopup.then(function(res) {
        if(res) {
          vm.finishOrder();
        } else {
          console.log('Ho intenta més tard');
        }
      });
    };

  });


