/**
 * Created by albert on 15/04/2016.
 */
angular.module('interceptor', [])
  .factory('interceptor', function($q, $log, $rootScope) {
    'use strict';
    /**
     * check if a request is a ajax request
     * @param  {object}  request the config file of the request interceptor
     * @return {Boolean}         true if is an ajax request
     */
    var isAjaxRequest = function(request) {
      var regExp0 = /application\/json/,
        regExp1 = /.json$/,
        regExp2 = /.html$/;

      var regResult = request ? regExp0.test(request.headers.Accept) && !regExp1.test(request.url) && !regExp2.test(request.url) : '';

      return regResult;
    };


    var requestInterceptor = {
      request: function(config) {

        if(isAjaxRequest(config)){
          config.headers['x-session-token'] = localStorage.getItem('bellboyApp_token');
        }

        return config;
      },
      response: function(response) {
        if(response.data.code){
          if(response.data.code === '301'){
            $log.error(response.data.message);
            if($rootScope.isAuth){
              $rootScope.showAlert('Sessió expirada', 'Has estat massa temps amb la sessió sense fer cap acció. Torna a fer Login per a gestionar qualsevol comanda.');
            }
            $rootScope.isAuth = false;
            $rootScope.logOut();
          }
        }

        return response;
      },
      responseError: function(rejection){

        return $q.reject(rejection);

      }
    };

    return requestInterceptor;

  });

