// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
var bellboyApp = angular.module('bellboyApp', ['ionic', 'context', 'api', 'views', 'user', 'order', 'food', 'shoppingCart','interceptor', 'app.menu', 'app.shoppingCart','app.stars'])

.run(function($ionicPlatform, $rootScope, $ionicSideMenuDelegate, $state, $ionicPopup, views, user, authService, shoppingCart, orderService, order) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    $rootScope.toggleLeft = function() {
      $ionicSideMenuDelegate.toggleLeft();
    };

    $rootScope.toggleRight = function() {
      $ionicSideMenuDelegate.toggleRight();
    };

    $rootScope.logOut = function() {
      $ionicSideMenuDelegate._instances[0].close();
      var token = localStorage.getItem('bellboyApp_token');

      //send service to logout
      authService.logout({token: token});

      //remove session info
      localStorage.removeItem('bellboyApp_token');
      $state.go(views.LOGIN);

    };

    $rootScope.goTo = function(view) {
      var state = '',
        params = {};
      switch (view){
        case 'mybellboy':
          state = views.MYBELLBOY;
          params.username = user.getUserInfo().username;
          break;
        case 'user':
              state = views.CLIENT;
              break;
        case 'foodCanRate':
          state = views.FOODCANRATE;
          break;

      }
      $ionicSideMenuDelegate.toggleLeft();
      $state.go(state, params);

    };

    $rootScope.isSideMenuEnabled = function() {
      return $state.current.name != views.LOGIN;

    };

    $rootScope.$on('shoppingCart', function(event, order){
      $rootScope.order = order;
      shoppingCart.setShoppingCart(order);
    });

    $rootScope.$on('rateFood', function(event, foodToRate){
      $rootScope.foodToRate = foodToRate;
    });


    // GlobalPopUpMessages
    $rootScope.showAlert = function(title, message) {
      var alertPopup = $ionicPopup.alert({
        title: title,
        template: message
      });

      alertPopup.then(function(res) {
        console.log(res);
      });
    };

    if($rootScope.isAuth){
      getOrder();
    }

    function getOrder(){
      orderService.getOrderByStatus({status: order.OPEN, username: user.getUserInfo().username}, function(data){
        $rootScope.$emit('shoppingCart', data);
      });
    }

  });

  $rootScope.$on('$stateChangeStart',
    function(event, toState, toParams, fromState, fromParams){
    })
});

