/**
 * Created by albert on 10/04/2016.
 */

var mongoose = require('mongoose'),
    Food = mongoose.model('Food'),
    Session = mongoose.model('Session'),
    User = mongoose.model('User'),
    Client = mongoose.model('Client');

/**
 * It retrieves all catalog
 * @param req
 * @param res
 */
exports.findAll = function(req, res){
    var token = req.headers['x-session-token'];
    Session.findOne({token: token}, function(err, results){

        if (err) return handleError(err);

        if(results){
            var time = results._doc.timestamp;
            var timeMax = time.setMinutes(time.getMinutes() + 20);
            if(timeMax > new Date()){
                Food.find({},function(err, results) {
                    return res.send(results);
                });
            }else{
                return res.send({code: '301', message: 'Sessió caducada'});
            }
        }
    });
};
exports.findById = function(req, res) {
    var token = req.headers['x-session-token'];
    var id = req.params.id;
    Session.findOne({token: token}, function(err, results){

        if (err) return handleError(err);

        if(results){
            var time = results._doc.timestamp;
            var timeMax = time.setMinutes(time.getMinutes() + 20);
            if(timeMax > new Date()){
                Food.findOne({'_id': id},function(errFood, resultsFood) {
                    if (errFood) return handleError(errFood);

                    if(resultsFood){
                        return res.send(resultsFood);
                    }
                });
            }else{
                return res.send({code: '301', message: 'Sessió caducada'});
            }
        }
    });
};
exports.updateRate = function(req, res) {
    var id = req.params.id,
        score = req.body.score,
        comment = req.body.comment,
        short = req.body.short,
        name = req.body.name;

    var token = req.headers['x-session-token'];

    Session.findOne({token: token}, function(errSession, resultsSession) {

        if (errSession) return handleError(errSession);

        if(resultsSession){
            Food.findOne({'_id': id},function(errFood, resultsFood) {
                if (errFood) return handleError(errFood);

                if(resultsFood){
                    var feedback = resultsFood._doc.feedback;
                    feedback.push(
                        {
                            score: score,
                            comment: comment,
                            short: short,
                            name: name,
                            date: new Date()
                        }
                    );
                    Food.update({_id: id}, { $set: {
                        feedback: feedback
                    }}, function(err, results){

                        if(results){
                            User.findOne({username: resultsSession._doc.username}, function(errUserInfo, resultsUserInfo){
                                if (errUserInfo) return handleError(errUserInfo);

                                if(resultsUserInfo){
                                    var foodCanRate = resultsUserInfo._doc.foodCanRate.filter(function(item){
                                        return item._id !== id;
                                    });

                                    User.update({username: resultsSession._doc.username}, { $set: {
                                        foodCanRate: foodCanRate
                                    }}, function(errUser, resultsUser){
                                        if (errUser) return handleError(errUser);

                                        if(resultsUser){
                                            return res.send(resultsUser);
                                        }
                                    });
                                }
                            });

                        }
                    });
                }
            });
        }
    });


};
exports.add = function() {};
exports.update = function() {};
exports.delete = function() {};
