/**
 * Created by albert on 10/04/2016.
 */

var mongoose = require('mongoose'),
    Order = mongoose.model('Order'),
    Session = mongoose.model('Session'),
    Food = mongoose.model('Food'),
    User = mongoose.model('User');

/**
 * It retrieves all Orders
 * @param req
 * @param res
 */
exports.findAll = function(req, res){
    Order.find({},function(err, results) {
        return res.send(results);
    });
};

exports.findMybellboy = function(req, res) {
    var username = req.params.username;
    var token = req.headers['x-session-token'];
    Session.findOne({token: token}, function(errSession, resultsSession){

        if (errSession) return handleError(errSession);

        if(resultsSession){
            var time = resultsSession._doc.timestamp;
            var timeMax = time.setMinutes(time.getMinutes() + 20);
            if(timeMax > new Date()){
                    Order.find({'username': username},function(err, results) {
                        if (err) return handleError(err);

                        if(results){
                            return res.send(results);
                        }
                    })
                    .where('status').ne(1);
            }else{
                return res.send({code: '301', message: 'Sessió caducada'});
            }
        }
    });

};

exports.findById = function(req, res) {
    var id = req.params.id;
    var token = req.headers['x-session-token'];
    Session.findOne({token: token}, function(errSession, resultsSession){

        if (errSession) return handleError(errSession);

        if(resultsSession){
            var time = resultsSession._doc.timestamp;
            var timeMax = time.setMinutes(time.getMinutes() + 20);
            if(timeMax > new Date()){
                Order.findOne({'_id': id},function(err, results) {
                    return res.send(results);
                });
            }else{
                return res.send({code: '301', message: 'Sessió caducada'});
            }
        }
    });
};

exports.findByStatus = function(req, res) {
    var status = req.params.status,
        username = req.params.username;
    var token = req.headers['x-session-token'];
    Session.findOne({token: token}, function(errSession, resultsSession){

        if (errSession) return handleError(errSession);

        if(resultsSession){
            var time = resultsSession._doc.timestamp;
            var timeMax = time.setMinutes(time.getMinutes() + 20);
            if(timeMax > new Date()){
                Order.findOne({'status': parseInt(status), 'username': username},function(err, results) {
                    return res.send(results);
                });
            }else{
                return res.send({code: '301', message: 'Sessió caducada'});
            }
        }
    });

};
exports.add = function(req, res) {
    var price = req.body.price,
        foodList = req.body.foodList;
    var token = req.headers['x-session-token'];
    Session.findOne({token: token}, function(err, results){

        if (err) return handleError(err);

        if(results){
            var time = results._doc.timestamp;
            var timeMax = time.setMinutes(time.getMinutes() + 20);
            if(timeMax > new Date()){
                var data = {
                    status : 1,
                    date : new Date(),
                    username: results._doc.username,
                    price : price,
                    foodList : foodList
                };

                var order = new Order(data);

                order.save(data, function(errOrder, resultsOrder){
                    if (errOrder) return handleError(errOrder);

                    if(resultsOrder){
                        return res.send(resultsOrder);
                    }
                });
            }else{
                return res.send({code: '301', message: 'Sessió caducada'});
            }
        }
    });
};
exports.update = function(req, res) {
    var id = req.params.id,
        status = req.body.status,
        price = req.body.price,
        foodList = req.body.foodList;

    var token = req.headers['x-session-token'];

    Session.findOne({token: token}, function(errSession, resultsSession) {

        if (errSession) return handleError(errSession);

        if(resultsSession){
            Order.update({_id: id}, { $set: {
                status: status,
                price: price,
                foodList: foodList
            }}, function(err, results){
                if (err) return handleError(err);

                if(results){
                    User.update({username: resultsSession._doc.username}, { $set: {
                        foodCanRate: foodList
                    }}, function(){});

                    return res.send(results);
                }
            });
        }
    });


};
exports.delete = function() {};
