/**
 * Created by albert on 10/04/2016.
 */

var mongoose = require('mongoose'),
    User = mongoose.model('User'),
    Session = mongoose.model('Session');

/**
 * It retrieves all Users
 * @param req
 * @param res
 */
exports.findAll = function(req, res){
    User.find({},function(err, results) {
        return res.send(results);
    });
};
exports.findByUsername = function(req, res) {
    var username = req.params.username;
    User.findOne({'username': username},function(err, results) {
        return res.send(results);
    });
};

exports.findByToken = function(req, res) {
    var token = req.headers['x-session-token'];
    Session.findOne({token: token}, function(errSession, resultsSession){

        if (errSession) return handleError(errSession);

        if(resultsSession){
            var time = resultsSession._doc.timestamp,
                username = resultsSession._doc.username;
            var timeMax = time.setMinutes(time.getMinutes() + 20);
            if(timeMax > new Date()){
                User.findOne({'username': username},function(err, results) {
                    if (err) return handleError(err);

                    if(results){
                        return res.send(results);
                    }
                });
            }else{
                return res.send({code: '301', message: 'Sessió caducada'});
            }
        }
    });
};
exports.add = function() {};
exports.update = function() {};
exports.delete = function() {};
