'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
    var reporter = arguments.length <= 0 || arguments[0] === undefined ? console.log : arguments[0];
    return function () {
        for (var _len = arguments.length, tasks = Array(_len), _key = 0; _key < _len; _key++) {
            tasks[_key] = arguments[_key];
        }

        return tasks.reduce(function (current, next) {
            return current.then(function (output) {
                var task = next(output);

                // nested Start
                if (task instanceof _promise2.default) {
                    return task;
                }

                var name = task.name;
                var taskPromise = undefined;

                reporter(name, 'start');

                // catch an errors that are outside of task Promise
                try {
                    taskPromise = task(reporter.bind(reporter, name, 'info'));
                } catch (error) {
                    reporter(name, 'reject', error);
                }

                return taskPromise.then(function (result) {
                    reporter(name, 'resolve');

                    return result;
                }).catch(function (error) {
                    reporter(name, 'reject', error);

                    throw error;
                });
            });
        }, _promise2.default.resolve());
    };
};

module.exports = exports['default'];