/**
 * Created by albert on 10/04/2016.
 */

module.exports = function(app){

    /** Auth **/
    var auth = require('./controllers/auth');
    app.post('/api/login', auth.login);
    app.post('/api/logout', auth.logout);

    /** Bill **/
    var bill = require('./controllers/bill');
    app.get('/api/bill', bill.findAll);
    app.get('/api/bill/:id', bill.findById);
    app.post('/api/bill', bill.add);
    app.put('/api/bill/:id', bill.update);
    app.delete('/api/bill/:id', bill.delete);

    /** Client **/
    var client = require('./controllers/client');
    app.get('/api/clients', client.findAll);
    app.get('/api/client/:id', client.findById);
    app.get('/api/client', client.findByToken);
    app.post('/api/client', client.add);
    app.put('/api/client/:id', client.update);
    app.delete('/api/client/:id', client.delete);

    /** Food **/
    var food = require('./controllers/food');
    app.get('/api/food', food.findAll);
    app.get('/api/food/:id', food.findById);
    app.post('/api/food', food.add);
    app.put('/api/food/:id', food.update);
    app.put('/api/food/:id/rate', food.updateRate);
    app.delete('/api/food/:id', food.delete);

    /** Order **/
    var order = require('./controllers/order');
    app.get('/api/orders', order.findAll);
    app.get('/api/orders/:username', order.findMybellboy);
    app.get('/api/order/:id', order.findById);
    app.get('/api/orderByStatus/:status/:username', order.findByStatus);
    app.post('/api/order', order.add);
    app.put('/api/order/:id', order.update);
    app.delete('/api/order/:id', order.delete);

    /** User **/
    var user = require('./controllers/user');
    app.get('/api/users', user.findAll);
    app.get('/api/user/:username', user.findByUsername);
    app.get('/api/user', user.findByToken);
    app.post('/api/user', user.add);
    app.put('/api/user/:id', user.update);
    app.delete('/api/user/:id', user.delete);
}
