/**
 * Created by albert on 10/04/2016.
 */

var express = require('express'),
    mongoose = require('mongoose'),
    fs = require('fs'),
    bodyParser = require('body-parser');

var mongoUri = 'mongodb://139.59.172.191/local';
mongoose.connect(mongoUri);
var db = mongoose.connection;
db.on('error', function () {
    throw new Error('unable to connect to database at ' + mongoUri);
});

var app = express();

app.use(function (req, res, next) {

    // Website you wish to allow to connect
    res.setHeader('Access-Control-Allow-Origin', 'http://localhost:8100');

    // Request methods you wish to allow
    res.setHeader('Access-Control-Allow-Methods', 'GET, POST, OPTIONS, PUT, PATCH, DELETE');

    // Request headers you wish to allow
    res.setHeader('Access-Control-Allow-Headers', 'Origin, X-Requested-With, Content-Type, Accept, Key, x-session-token');

    // Set to true if you need the website to include cookies in the requests sent
    // to the API (e.g. in case you use sessions)
    res.setHeader('Access-Control-Allow-Credentials', true);

    // Pass to next layer of middleware
    next();
});

app.use(bodyParser.urlencoded());
app.use(bodyParser.json());

require('./models/bill');
require('./models/client');
require('./models/food');
require('./models/order');
require('./models/session');
require('./models/user');

require('./routes')(app);


app.listen(3001);
console.log('Listening on port 3001...');
